function string_array_add(e){
	
	var element   = $(e);
	var name      = parse_name(element.name);
	var base  	  = name.attribute;
	var block 	  = $(e + "_block");
	var container = $(base + "_array");
	
	var new_int         = container.getChildren().length;
	
	var new_input_id    = base + "_" + new_int;
	var new_input_name  = name.model + "[" + base + "][]";
	
	var new_input       = new Element('input',{
		'id':new_input_id,
		'name':new_input_name,
		'type':'text'
	});
	
	var new_control     = new Element('input',{
		'class':'auto-width-input',
		'type':'button',
		'value':'+',
		'events':{
			'click':function(){
				string_array_add(new_input_id);
			}
		}
	});
	
	var new_block_id    = new_input_id + "_block";
	var new_block_class = "form-input array-input";
	
	var new_block 		= new Element('div',{
		'id':new_block_id,
		'class':new_block_class,
		'style':{
			'opacity':0
		}
	})
	
	new_block.adopt([new_input,new_control]);
	
	var fx = new Fx.Tween(new_block);
	
	new_block.injectAfter(block);
	
	fx.start('opacity',0,1);
	
}

function select_array_add(e){
	
	var element   = $(e);
	var name      = parse_name($(e).name);
	var base  	  = name.attribute;
	var block 	  = $(e + "_block");
	var container = $(base + "_array");
	
	var new_int         = container.getChildren().length;
	
	var new_select_id   = base + "_" + new_int;
	var new_select_name = name.model + "[" + base + "][]";
	
	var new_select      = element.clone();
	
	new_select.set({
		'id':new_select_id,
		'name':new_select_name
	});
	
	clear_selection(new_select);
	
	var new_control     = new Element('input',{
		'class':'auto-width-input',
		'type':'button',
		'value':'+',
		'events':{
			'click':function(){
				select_array_add(new_select_id);
			}
		}
	});
	
	var new_block_id    = new_select_id + "_block";
	var new_block_class = "form-input array-input";
	
	var new_block 		= new Element('div',{
		'id':new_block_id,
		'class':new_block_class,
		'style':{
			'opacity':0
		}
	})
	
	new_block.adopt([new_select,new_control]);
	
	var fx = new Fx.Tween(new_block);
	
	new_block.injectAfter(block);
	
	fx.start('opacity',0,1);
	
}

function nested_select_array_add(e){
	
	var element   = $(e);
	var name      = parse_name($(e).name);
	var base  	  = name.attribute;
	var block 	  = $(e + "_block");
	var container = $(base + "_array");
	var parent    = $("parent_" + e);
	
	var new_int         = container.getChildren().length;
	
	var new_select_id   = base + "_" + new_int;
	var new_select_name = name.model + "[" + base + "][]";
	
	var new_parent_id   = "parent_" + new_select_id;
	var new_parent_name = "parent_" + base + "[]";
	
	var new_select      = element.clone(false);
	
	var new_parent      = parent.clone();
	
	new_select.set({
		'id':new_select_id,
		'name':new_select_name
	});
	
	new_parent.set({
		'id':new_parent_id,
		'name':new_parent_name
	});
	
	clear_selection(new_parent);
	
	var new_control     = new Element('input',{
		'class':'auto-width-input',
		'type':'button',
		'value':'+',
		'events':{
			'click':function(){
				nested_select_array_add(new_select_id);
			}
		}
	});
	
	var new_block_id    = new_select_id + "_block";
	var new_block_class = "form-input array-input";
	
	var new_block 		= new Element('div',{
		'id':new_block_id,
		'class':new_block_class,
		'style':{
			'opacity':0
		}
	})
	
	new_block.adopt([new_parent,new_control,new_select]);
	
	var fx = new Fx.Tween(new_block);
	
	new_block.injectAfter(block);
	
	fx.start('opacity',0,1);
	
}

function nested_select_array_change(parent){
	
	var name      = parse_parent_name(parent.id);
	var select 	  = $(name.attribute + "_" + name.id);
	
	select.empty();
	
	if(parent.value != ""){
	
		var inventory = $(name.attribute + "_inventory");
		var section   = $(name.attribute + "_options_for_" + parent.value);
	
		var options   = [];
	
		section.getChildren().each(function(option){
			var opt = new Element('option',{
				'value':parse_id(option.id)
			});
		
			opt.set('html',option.innerHTML);
		
			options.push(opt);
		});
	
		select.adopt(options);
	
	}
	
}

function nested_select_change(select){
    
    var child_select_id = select.id.match(/parent_(.+)/)[1];
    var child_select    = $(child_select_id)
    var hidden_input    = $("hidden_" + child_select_id);
    
    child_select.empty();
    hidden_input.value = "";
    
    if(select.value != ""){
        
        var inventory = $(child_select_id + "_inventory");
        var section   = $(child_select_id + "_options_for_" + select.value);
        
        var options   = [];
        
        section.getChildren().each(function(option){
			var opt = new Element('option',{
				'value':parse_id(option.id)
			});
		
			opt.set('html',option.innerHTML);
		
			options.push(opt);
		});
	
		child_select.adopt(options);
          
        hidden_input.value = child_select.value;
    }
    
}

function nested_select_child_change(select){
    
    var hidden_input = $("hidden_" + select.id);
     
    hidden_input.value = select.value;
    
}

function clear_selection(select){
	select.getChildren().each(function(e){
		e.selected = false;
	});
}

function parse_name(name){
	var components = {};
	var matches    = name.match(/(.+)\[(.+)\]\[\]/);
	
	components.model     = matches[1];
	components.attribute = matches[2];
	
	return components;
}

function parse_parent_name(name){
	var components = {};
	var matches    = name.match(/parent_(.+)_([0-9]+)/);
	
	components.attribute = matches[1];
	components.id        = matches[2];

	return components;
}

function parse_id(name){
	return name.match(/[0-9]+$/)[0];
}

function is_digit(digit){
	if(digit == ""){
		return false;
	}
	var extract = digit.match(/[0-9]+/);
	return (extract == digit);
}


// URL Class

var Url = new Class({
	initialize:function(url){
		this.url = url;
		this.extractTokens();
	},
	extractTokens:function(){
		var tokens = this.url.match(/^(.+):\/\/(.+?):([0-9]+)*\//);
		if(!tokens){
			this.port = 80;
			tokens = this.url.match(/^(.+):\/\/(.+?)\//);
		} else {
			this.port = tokens[3].toInt();
		}
		this.protocol = tokens[1];
		this.host     = tokens[2];
		this.extractPath();
	},
	extractPath:function(){
		this.path = this.url.match(/^.+:\/\/.+?(\/.+)$/)[1];
		var relative = this.path.match(/^\/(.+)/)[1];
		this.path_components = relative.split('/');
	}
});

function paired_lexis_category_change(parent){
    
    //lexis_pairing_paired_lexis_category_id_1
    //lexis_pairing_paired_lexis_id_1
    
    var category_id = parse_id(parent.id) 
	var select 	    = $("lexis_pairing_paired_lexis_id_" + category_id);
	
	select.empty();
	
	if(parent.value != ""){
	
		var inventory = $("pairing_inventory_" + parent.value);	
		var options   = [];
	
		inventory.getChildren().each(function(option){
			var opt = new Element('option',{
				'value':parse_id(option.id)
			});
		
			opt.set('html',option.innerHTML);
		
			options.push(opt);
		});
	
		select.adopt(options);
	
	}
    
}


function lexis_pairing_add(e){

    var element = e.getParent();
    var clone   = element.clone(true,true);
    var index   = element.getParent().getChildren().length;
    
    clone.id    = "lexis_pairing_" + index;
    
    clone.getElements('select').each(function(select){
       var id_stem = select.id.match(/^(.*_)[0-9]+$/)[1];
       select.id   = id_stem + index; 
    });
    
    clone.setStyle('opacity',0)
    clone.inject(element,'after');
    
    $('lexis_pairing_paired_lexis_category_id_' + index).value = "";
    $('lexis_pairing_paired_lexis_id_' + index).empty();
    
    var fx = new Fx.Tween(clone);
    fx.start('opacity',0,1);
    
}